'File Name: Add_Remove.vbs
'
'Requirements:-
'--------------
'Script is for .Net written plugins.
'Windows Scripting Host version 5.6.
'
'Script assumes that the plugin will create/remove the registry entry to "SOFTWARE\Patchou\MsgPlus2\RegisteredPlugins"
'using com install registry or com uninstall registry. In other words this script will not add a registry entry to
'said registry path.
'
'Outline of the script:-
'-----------------------
'Checks if the following program are installed by using the registry.
'- Messenger Plus!
'- Microsoft .Net
'- MSN Messenger
'
'If any of the above program is not found, script will prompt and quit.
'
'Check if MSN Messenger is running.
'
'Ensures that plugin is in the Messenger Plus! plugin directory.
'
'Checks if the plugin has been installed before.
'If it has been installed, the plugin will be uninstalled and vice versa.
'
'Register the plugin.
'
'Start MSN Messenger if it was running before.
'
'Notes:-
'-------
'Script only checks if the required programs are installed. It does not check the program's version.
'
'Revision History
'----------------
'Created: 2005 August 11, 14:13
'Modified: 2005 September 01, 21:59
'
'Version: 1.1
'2005 September 01, 21:59
'- Fixed wrong registry checking for Microsoft .Net Version.
Option Explicit


' *****************************************************************************
'
' Changable Variables
'
' *****************************************************************************

Dim PluginName: PluginName					= "Count_Detector"			'Plugin's name that is entered into the registry.
Dim PluginFileName: PluginFileName			= "count detector.dll"		'Plugin's file name.

'URL to download the program.
Dim MsnMsgURL: MsnMsgURL					= "http://messenger.msn.com"
Dim MsNetURL: MsNetURL						= "http://www.microsoft.com"
Dim MsgPlusURL: MsgPlusURL					= "http://www.msgplus.net"

'Info/warning messages.
Dim langDownloadAt: langDownloadAt			= "Please download at: "
Dim langNoMsgPlus: langNoMsgPlus			= "Messenger Plus! not installed."
Dim langNoMsnMsg: langNoMsnMsg				= "MSN Messenger not installed."
Dim langNoMsNet: langNoMsNet				= "MSN .Net Framework not installed."
Dim langCloseMsnMsg: langCloseMsnMsg		= "MSN Messenger needs to be closed before plugin can be installed. Terminate MSN Messenger?"
Dim langAddPlugin: langAddPlugin			= "Add plugin "
Dim langRemovePlugin: langRemovePlugin		= "Remove plugin "
Dim langNoPlugin: langNoPlugin				= "Cannot find plugin. Please ensure that the plugin is in this directory-> "

'Error messages.
Dim langExecFail: langExecFail				= "WshShell.Exec failed."

Dim MsNetKeyPath: MsNetKeyPath				= "SOFTWARE\Microsoft\.NETFramework"
Dim MsNetVerKeyPath: MsNetVerKeyPath		= "SOFTWARE\Microsoft\.NETFramework\policy"
Dim MsNetDirName: MsNetDirName				= "InstallRoot"

Dim MsnMsgFileName: MsnMsgFileName			= "msnmsgr.exe"
Dim MsnMsgKeyPath: MsnMsgKeyPath			= "SOFTWARE\Microsoft\MSNMessenger"
Dim MsnMsgDirName: MsnMsgDirName			= "InstallationDirectory"

Dim MsgPlusKeyPath: MsgPlusKeyPath			= "SOFTWARE\Patchou\MsgPlus2"
Dim MsgPlusRegPlugin: MsgPlusRegPlugin		= "SOFTWARE\Patchou\MsgPlus2\RegisteredPlugins"
Dim MsgPlusPluginName: MsgPlusPluginName	= "PluginDir"


' *****************************************************************************
'
' Script Variables
'
' *****************************************************************************

Const HKEY_CLASSES_ROOT 	= &H80000000
Const HKEY_CURRENT_USER 	= &H80000001
Const HKEY_LOCAL_MACHINE 	= &H80000002
Const HKEY_USERS 			= &H80000003
Const HKEY_CURRENT_CONFIG 	= &H80000005

Dim strComputer: strComputer = "."

Dim oReg: Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\default:StdRegProv")

Dim strValue, arrSubKeys, SubKey, arrValueNames, ValueName, tmpValueName, arrValueTypes

Dim MsNetDir, MsNetVersion, MsnMsgDir, MsgPlusPluginDir


' *****************************************************************************
'
' Check Registry
'
' *****************************************************************************

'Start checking the registry for
'- Messenger Plus! plugin directory
'- MSN Messenger install directory
'- Microsoft .Net Framework directory
'- Microsoft .Net Framework version

oReg.GetStringValue HKEY_LOCAL_MACHINE, MsgPlusKeyPath, MsgPlusPluginName, strValue
If IsNull(strValue) Then
	MsgBox langNoMsgPlus & vbCRLF & vbCRLF & langDownloadAt & MsgPlusURL
	WScript.Quit
End If
MsgPlusPluginDir = strValue

oReg.GetStringValue HKEY_LOCAL_MACHINE, MsnMsgKeyPath, MsnMsgDirName, strValue
If IsNull(strValue) Then
	MsgBox langNoMsnMsg & vbCRLF & vbCRLF & langDownloadAt & MsnMsgURL
	WScript.Quit
End If
MsnMsgDir = strValue

oReg.GetStringValue HKEY_LOCAL_MACHINE, MsNetKeyPath, MsNetDirName, strValue
If IsNull(strValue) Then
	MsgBox langNoMsNet & vbCRLF & vbCRLF & langDownloadAt & MsNetURL
	WScript.Quit
End If
MsNetDir = strValue

oReg.EnumKey HKEY_LOCAL_MACHINE, MsNetVerKeyPath, arrSubKeys
If IsNull(arrSubKeys) Then
	MsgBox langNoMsNet & vbCRLF & vbCRLF & langDownloadAt & MsNetURL
	WScript.Quit
End If
'If .Net has been upgraded, there will be multiple entries. The last entry
'is the lastest version.
For Each SubKey in arrSubKeys
	MsNetVersion = SubKey
Next
'This will retrieve all the values and type, so that we can get the build number.
oReg.EnumValues HKEY_LOCAL_MACHINE, MsNetVerKeyPath & "\" & MsNetVersion, arrValueNames, arrValueTypes
'The last entry is the build number.
For Each ValueName in arrValueNames
    tmpValueName = ValueName
Next
MsNetVersion = MsNetVersion & "." & tmpValueName


' *****************************************************************************
'
' Check Process
'
' *****************************************************************************

'Check to see if MSN Messenger is running and terminate it.
Dim objWMIService, ColProcessList, objProcess, ret, IsMsnMsgRunning

Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set colProcessList = objWMIService.ExecQuery ("SELECT * FROM Win32_Process WHERE Name = " & "'" & MsnMsgFileName & "'")

For Each objProcess in colProcessList
	ret = MsgBox(langCloseMsnMsg, vbYesNo)
	If ret = vbYes Then
		objProcess.Terminate()
		IsMsnMsgRunning = True
		Exit For
	End If
    WScript.Quit
Next

'Check if the plugin is installed
Dim IsInstalled
oReg.GetStringValue HKEY_LOCAL_MACHINE, MsgPlusRegPlugin, PluginName, strValue
If IsNull(strValue) Then
	IsInstalled = false
	ret = MsgBox(langAddPlugin & PluginName & "?", vbYesNo)
else
	IsInstalled = true
	ret = MsgBox(langRemovePlugin & PluginName & "?", vbYesNo)
End If

If ret = vbNo Then
	WScript.Quit
End If


' *****************************************************************************
'
' Call Regasm
'
' *****************************************************************************

'Setup the full path to .Net regasm.exe and the plugin.
Dim RegasmPath: RegasmPath = AddTrailingSlash(AddTrailingSlash(MsNetDir) & MsNetVersion)
Dim PluginPath: PluginPath = AddTrailingSlash(MsgPlusPluginDir) & PluginFileName

'Check if the plugin is in the Messenger Plus! plugin directory.
IsFileExist PluginPath, MsgPlusPluginDir

Dim objShell: Set objShell = CreateObject("WScript.Shell")

Dim cmd

If IsInstalled Then
	cmd = RegasmPath & "regasm /unregister " & """" & PluginPath & """"
Else
	cmd = RegasmPath & "regasm /codebase " & """" & PluginPath & """"
End If

'Execute the command, and display any message. This will output any message
'from regasm to msgbox.
Dim WSEXE: Set WSEXE = objShell.Exec(cmd)

If WSEXE.ProcessID = 0 And WSEXE.Status = 1 Then
	Err.Raise vbObjectError,,langExecFail
End If

Dim Status, StdMsg

Do
	Status = WSEXE.Status
	
	StdMsg = WSEXE.StdOut.ReadAll()
	
	If StdMsg <> "" Then
		MsgBox StdMsg
	End If
	
	StdMsg = WSEXE.StdErr.ReadAll()
	
	If StdMsg <> "" Then
		MsgBox StdMsg
	End If
	
	If Status <> 0 Then Exit Do
	
	WScript.Sleep 10
Loop

If IsMsnMsgRunning Then
	objShell.Run("""" & AddTrailingSlash(MsnMsgDir) & MsnMsgFileName & """"), 1
End If


' *****************************************************************************
'
' Script Functions
'
' *****************************************************************************

Function AddTrailingSlash(ByVal strValue)
	If (Right(strValue, 1) <> "\") Then
		strValue = strValue & "\"
	End If
	
	AddTrailingSlash = strValue
End Function

Function IsFileExist(ByVal FilePath, FileDir)
	Dim filesys: Set FileSys = CreateObject ("Scripting.FileSystemObject")
	
	On Error Resume Next
	
	Dim getFile: Set getFile = FileSys.GetFile(FilePath)
	
	If Err.Number = 53 Then
		MsgBox langNoPlugin & FileDir
		WScript.Quit
	ElseIf Err.Number <> 0 Then
		MsgBox Err.Number & ": " & Err.Description
		WScript.Quit
	End if
End Function